; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : DigitalClock - Date
; File Name : DigitalClock - Date.pb
; File version: 5.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 07-09-2016
; Last Update : 07-09-2016
; PureBasic code : V5.50
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Date

  Declare Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w, P_DateMask.s = "%dd-%mm-%yyyy")
  Declare Reset()
  Declare Display()
  
EndDeclareModule

Module Date

  Structure Instance
    
    
    Center.Vector2W::Vector2W
    Digit00.Vector2W::Vector2W[21]
    Digit01.Vector2W::Vector2W[21]
    Digit02.Vector2W::Vector2W[21]
    Digit03.Vector2W::Vector2W[21]
    Digit04.Vector2W::Vector2W[2]
    Digit05.Vector2W::Vector2W[21]
    Digit06.Vector2W::Vector2W[21]
    Digit07.Vector2W::Vector2W[2]
    Digit08.Vector2W::Vector2W[21]
    Digit09.Vector2W::Vector2W[21]
    SpriteID.l
    DateMask.s
    
  EndStructure

  Global Instance.Instance
    
  Macro IsNotBetween(Value, Lower, Upper)
    
    ((Value) < (Lower) Or (Value) > (Upper))
    
  EndMacro
  
  Procedure Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w, P_DateMask.s = "%dd-%mm-%yyyy")
    
    Vector2W::Update(Instance\Center, P_CenterX, P_CenterY)
    
    Vector2W::Update(Instance\Digit00[00], -50, -8)
    Vector2W::Update(Instance\Digit00[01], -48, -8)
    Vector2W::Update(Instance\Digit00[02], -46, -8)
    
    Vector2W::Update(Instance\Digit00[03], -50, 0)
    Vector2W::Update(Instance\Digit00[04], -48, 0)
    Vector2W::Update(Instance\Digit00[05], -46, 0)
    
    Vector2W::Update(Instance\Digit00[06], -50, 8)
    Vector2W::Update(Instance\Digit00[07], -48, 8)
    Vector2W::Update(Instance\Digit00[08], -46, 8)
    
    Vector2W::Update(Instance\Digit00[09], -52, -6)
    Vector2W::Update(Instance\Digit00[10], -52, -4)
    Vector2W::Update(Instance\Digit00[11], -52, -2)
    
    Vector2W::Update(Instance\Digit00[12], -52, 2)
    Vector2W::Update(Instance\Digit00[13], -52, 4)
    Vector2W::Update(Instance\Digit00[14], -52, 6)
    
    Vector2W::Update(Instance\Digit00[15], -44, -6)
    Vector2W::Update(Instance\Digit00[16], -44, -4)
    Vector2W::Update(Instance\Digit00[17], -44, -2)
    
    Vector2W::Update(Instance\Digit00[18], -44, 2)
    Vector2W::Update(Instance\Digit00[19], -44, 4)
    Vector2W::Update(Instance\Digit00[20], -44, 6)
    
    
    For Index = 0 To 20
      
      Vector2W::SetI(Instance\Digit01[Index], Vector2W::GetI(Instance\Digit00[Index]) + 12)
      Vector2W::SetJ(Instance\Digit01[Index], Vector2W::GetJ(Instance\Digit00[Index]))

      Vector2W::SetI(Instance\Digit02[Index], Vector2W::GetI(Instance\Digit00[Index]) + 24)
      Vector2W::SetJ(Instance\Digit02[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      
      Vector2W::SetI(Instance\Digit03[Index], Vector2W::GetI(Instance\Digit00[Index]) + 36)
      Vector2W::SetJ(Instance\Digit03[Index], Vector2W::GetJ(Instance\Digit00[Index]))

      Vector2W::SetI(Instance\Digit05[Index], Vector2W::GetI(Instance\Digit00[Index]) + 54)
      Vector2W::SetJ(Instance\Digit05[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      
      Vector2W::SetI(Instance\Digit06[Index], Vector2W::GetI(Instance\Digit00[Index]) + 66)
      Vector2W::SetJ(Instance\Digit06[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      
      Vector2W::SetI(Instance\Digit08[Index], Vector2W::GetI(Instance\Digit00[Index]) + 84)
      Vector2W::SetJ(Instance\Digit08[Index], Vector2W::GetJ(Instance\Digit00[Index]))

      Vector2W::SetI(Instance\Digit09[Index], Vector2W::GetI(Instance\Digit00[Index]) + 96)
      Vector2W::SetJ(Instance\Digit09[Index], Vector2W::GetJ(Instance\Digit00[Index]))

    Next

    Vector2W::Update(Instance\Digit04[00], -4, 0)
    Vector2W::Update(Instance\Digit04[01], -2, 0)
    
    Vector2W::Update(Instance\Digit07[00], 26, 0)
    Vector2W::Update(Instance\Digit07[01], 28, 0)
    
    Instance\SpriteID = Diode::Make(4, P_LEDSize)
    Instance\DateMask = P_DateMask
    
    For Index = 0 To 20
      Vector2W::ProductByScalar(Instance\Digit00[Index], Instance\Digit00[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit01[Index], Instance\Digit01[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit02[Index], Instance\Digit02[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit03[Index], Instance\Digit03[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit05[Index], Instance\Digit05[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit06[Index], Instance\Digit06[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit08[Index], Instance\Digit08[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit09[Index], Instance\Digit09[Index], P_LEDSize)
      Vector2W::Minus(Instance\Digit00[Index], Instance\Center, Instance\Digit00[Index])
      Vector2W::Minus(Instance\Digit01[Index], Instance\Center, Instance\Digit01[Index])
      Vector2W::Minus(Instance\Digit02[Index], Instance\Center, Instance\Digit02[Index])
      Vector2W::Minus(Instance\Digit03[Index], Instance\Center, Instance\Digit03[Index])
      Vector2W::Minus(Instance\Digit05[Index], Instance\Center, Instance\Digit05[Index])
      Vector2W::Minus(Instance\Digit06[Index], Instance\Center, Instance\Digit06[Index])
      Vector2W::Minus(Instance\Digit08[Index], Instance\Center, Instance\Digit08[Index])
      Vector2W::Minus(Instance\Digit09[Index], Instance\Center, Instance\Digit09[Index])
    Next

    For Index = 0 To 1
      Vector2W::ProductByScalar(Instance\Digit04[Index], Instance\Digit04[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit07[Index], Instance\Digit07[Index], P_LEDSize)
      Vector2W::Minus(Instance\Digit04[Index], Instance\Center, Instance\Digit04[Index])
      Vector2W::Minus(Instance\Digit07[Index], Instance\Center, Instance\Digit07[Index])
    Next

  EndProcedure

  Procedure Reset()
    
    Vector2W::Reset(Instance\Center)
    
    For Digit00ID = 0 To 20
      Vector2W::Reset(Instance\Digit00[Digit00ID])
      Vector2W::Reset(Instance\Digit01[Digit00ID])
      Vector2W::Reset(Instance\Digit02[Digit00ID])
      Vector2W::Reset(Instance\Digit03[Digit00ID])
      Vector2W::Reset(Instance\Digit05[Digit00ID])
      Vector2W::Reset(Instance\Digit06[Digit00ID])
      Vector2W::Reset(Instance\Digit08[Digit00ID])
      Vector2W::Reset(Instance\Digit09[Digit00ID])
    Next
    
    For Digit04ID = 0 To 1
      Vector2W::Reset(Instance\Digit04[Digit04ID])
      Vector2W::Reset(Instance\Digit07[Digit04ID])
    Next
    
    If IsSprite(Instance\SpriteID)
      FreeSprite(Instance\SpriteID)
      Instance\SpriteID = 0
    EndIf
    
  EndProcedure

  Procedure Display()
    
    Year.s = Str(LocalTime::GetYear())
    Digit001 = Val(Mid(Year, 1, 1))
    Digit002 = Val(Mid(Year, 2, 1))
    Digit003 = Val(Mid(Year, 3, 1))
    Digit004 = Val(Mid(Year, 4, 1))
    
    If Instance\DateMask = "%dd-%mm-%yyyy"
      
      Digit005 = LocalTime::GetMonth() / 10
      Digit006 = LocalTime::GetMonth() - (10 * Digit005)  
      
      Digit007 = LocalTime::GetDay() / 10
      Digit008 = LocalTime::GetDay() - (10 * Digit007)   
      
    ElseIf Instance\DateMask = "%mm-%dd-%yyyy"
      
      Digit005 = LocalTime::GetDay() / 10
      Digit006 = LocalTime::GetDay() - (10 * Digit005)  
      
      Digit007 = LocalTime::GetMonth() / 10
      Digit008 = LocalTime::GetMonth() - (10 * Digit007)   
      
    EndIf
    
    Select Digit004
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Digit003
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Digit002
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
          EndIf
        Next
        
    EndSelect    

    Select Digit001
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
    EndSelect    

    Select Digit006
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
          EndIf
        Next
        
    EndSelect    
    
    Select Digit005
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
    EndSelect    

    Select Digit008
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit08[Index]), Vector2W::GetJ(Instance\Digit08[Index]))
          EndIf
        Next
        
    EndSelect    
    
    Select Digit007
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit09[Index]), Vector2W::GetJ(Instance\Digit09[Index]))
          EndIf
        Next
        
    EndSelect    

    For Index = 0 To 1
      DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
      DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
    Next

  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory